#!/usr/bin/env bats

##################################################
### ------ Test Method utils functions ------- ###
##################################################


### ----------------- Setup ------------------ ###

setup() {
    load '../test_helper/common-setup'
    _common_setup
}

### ------------------------------------------ ###
### ----------------- Tests ------------------ ###
### ------------------------------------------ ###

### -----------------  ------------------ ###


@test "get_method_param_combs" {
   
   # Generate param.json 
   declare -A PARAM_JS=(
      ['param1']="1 2"
      ['param2']="A B C"
    )
    OUT_FILE=$BATS_TEST_TMPDIR/param_values.json
    out_json='{}'
    
    for key in "${!PARAM_JS[@]}"; do
        out_json=$(jq -n --argjson v "$(printf '"%s"' "${PARAM_JS[$key]}")" --argjson out "$out_json" --arg key "$key" '$out + {($key): [$v]}')
    done
    
    echo -e "${out_json}\n" > $OUT_FILE
    
    # Generate methods param array 
    declare -A PARAM_AR=(
      ['param1']=1
      ['param2']=C
    )
    
    run get_method_param_combs $OUT_FILE PARAM_AR 
    
    assert_output --partial 'param1=1_param2=A param1=1_param2=B param1=1_param2=C param1=2_param2=A param1=2_param2=B param1=2_param2=C'
    
}
