#!/usr/bin/env bats

##################################################
### ------ Test Method utils functions ------- ###
##################################################


### ----------------- Setup ------------------ ###

setup() {
    load '../test_helper/common-setup'
    _common_setup
}

### ------------------------------------------ ###
### ----------------- Tests ------------------ ###
### ------------------------------------------ ###

### -----------------general------------------ ###



func_list=( run_command_on_unprocessed find_datasets_to_process find_files_to_process list_plan_outputs list_plan_inputs list_dataset_files )

help_list=( help_run_command_on_unprocessed help_find_datasets_to_process help_find_files_to_process help_list_plan_outputs help_list_plan_inputs help_list_dataset_files )

@test "raise option error for list of functions" {
    index=0
    for func in "{$func_list[@]}"; do
        echo "{$help_list[$index]}" > res
        run "{$func}" -h 
        assert_output --partial res
        run run_command_on_unprocessed -nonsense
        assert_output --partial 'Error: Invalid option'
        run run_command_on_unprocessed -H
        assert_output --partial 'Error: Invalid option'
        run run_command_on_unprocessed -aldfkjad
        assert_output --partial 'Error: Invalid option'
        let "index+=1"
    done 
}